#!/bin/bash
set -e

# DESCRIPTION
#  taking a list of files, write a prom metrics file (for node_exporter)
#  with the timestamp and size of the first file found
# ARGS
#  $1 = prefix for metric
#  $2 = description of file
#  $3.. files to check, use first found

name="$1"
what="$2"
shift 2

file="$name"
while true ; do
    case "$1" in
        "--labels") LABELS="$2" ; shift 2 ;;
        "--file") file="$2" ; shift 2 ;;
        "--") break ;;
        *) break ;;
    esac
done

for NCFILE in "$@" ; do
    if test -r "$NCFILE" ; then
        LATEST_SIZE=`stat -c "%s" "$NCFILE"`
        LATEST_MTIME=`stat -c "%Y" "$NCFILE"`
        break
    fi
done

PROMDIR={{ node_exporter_textfile_dir | quote }}
PROMFILE="$PROMDIR/$file.prom"

if test -n "$LATEST_MTIME" -a -n "$LATEST_SIZE" ; then
    GAUGE_SIZE="${name}_size_bytes"
    GAUGE_MTIME="${name}_timestamp"
    cat <<EOF > "$PROMFILE.$$"
# TYPE $GAUGE_SIZE gauge
# UNIT $GAUGE_SIZE bytes
# HELP $GAUGE_SIZE Size of $what
$GAUGE_SIZE$LABELS $LATEST_SIZE
# TYPE $GAUGE_MTIME gauge
# UNIT $GAUGE_MTIME seconds
# HELP $GAUGE_MTIME Timestamp (seconds since epoch) of $what
$GAUGE_MTIME$LABELS $LATEST_MTIME
EOF
    mv "$PROMFILE.$$" "$PROMFILE"
else
    rm -f "$PROMFILE"
fi
